/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 *  ianjuta-buildable.h -- Autogenerated from libanjuta.idl
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _IANJUTA_BUILDABLE_H_
#define _IANJUTA_BUILDABLE_H_

#include <glib-object.h>

G_BEGIN_DECLS

#define IANJUTA_TYPE_BUILDABLE (ianjuta_buildable_get_type ())
#define IANJUTA_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IANJUTA_TYPE_BUILDABLE, IAnjutaBuildable))
#define IANJUTA_IS_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IANJUTA_TYPE_BUILDABLE))
#define IANJUTA_BUILDABLE_GET_IFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), IANJUTA_TYPE_BUILDABLE, IAnjutaBuildableIface))

	
#define IANJUTA_BUILDABLE_ERROR ianjuta_buildable_error_quark()

typedef struct _IAnjutaBuildable IAnjutaBuildable;
typedef struct _IAnjutaBuildableIface IAnjutaBuildableIface;

struct _IAnjutaBuildableIface {
	GTypeInterface g_iface;
	

	void (*build) (IAnjutaBuildable *obj, const gchar *uri, GError **err);
	void (*clean) (IAnjutaBuildable *obj, const gchar *uri, GError **err);
	void (*configure) (IAnjutaBuildable *obj, const gchar *uri, GError **err);
	void (*execute) (IAnjutaBuildable *obj, const gchar *uri, GError **err);
	void (*generate) (IAnjutaBuildable *obj, const gchar *uri, GError **err);
	void (*install) (IAnjutaBuildable *obj, const gchar *uri, GError **err);

};
GQuark ianjuta_buildable_error_quark     (void);
GType  ianjuta_buildable_get_type        (void);

void ianjuta_buildable_build (IAnjutaBuildable *obj, const gchar *uri, GError **err);

void ianjuta_buildable_clean (IAnjutaBuildable *obj, const gchar *uri, GError **err);

void ianjuta_buildable_configure (IAnjutaBuildable *obj, const gchar *uri, GError **err);

void ianjuta_buildable_execute (IAnjutaBuildable *obj, const gchar *uri, GError **err);

void ianjuta_buildable_generate (IAnjutaBuildable *obj, const gchar *uri, GError **err);

void ianjuta_buildable_install (IAnjutaBuildable *obj, const gchar *uri, GError **err);


G_END_DECLS

#endif
